package jp.programmers.pizza.dao;

import java.util.List;

import jp.programmers.pizza.model.Customer;
import net.sf.hibernate.Hibernate;
import net.sf.hibernate.HibernateException;
import net.sf.hibernate.Session;
import net.sf.hibernate.Transaction;

/**
 * DAONX
 */
public class CustomerDAO extends BaseDAO {

    /** dbԍ܂B */
    public Customer findByPhone(String phone) {
        Customer result = null;
        Session session = null;
        try {
            session = getSession();
            List list = session.find(
                "from Customer where phone = ?",
                phone, Hibernate.STRING);
            if (!list.isEmpty()) {
                result = (Customer)list.get(0);
            }
        } catch (HibernateException ex) {
            throw new RuntimeException(ex.getMessage());
        } finally {
            if (session != null) {
                try {
                    session.close();
                } catch (HibernateException ignore) { }
            }
        }
        return result;
    }

    /** ۑ܂B */
    public void saveOrUpdate(Customer customer) {
        Session session = null;
        Transaction transaction = null;
        try {
            session = getSession();
            transaction = session.beginTransaction();
            session.saveOrUpdate(customer);
            transaction.commit();
        } catch (HibernateException ex) {
            if (transaction != null) {
                try {
                    transaction.rollback();
                } catch (HibernateException ignore) { }
            }
            throw new RuntimeException(ex.getMessage());
        } finally {
            if (session != null) {
                try {
                    session.close();
                } catch (HibernateException ignore) { }
            }
        }
    }

}
