package jp.programmers.pizza.dao;

import java.io.Serializable;
import java.util.Date;
import java.util.List;

import jp.programmers.pizza.model.Order;
import net.sf.hibernate.Criteria;
import net.sf.hibernate.Hibernate;
import net.sf.hibernate.HibernateException;
import net.sf.hibernate.Session;
import net.sf.hibernate.Transaction;
import net.sf.hibernate.expression.Expression;

/**
 * I[_DAONX
 */
public class OrderDAO extends BaseDAO {

    /** I[_ۑ܂B */
    public void save(Order order) {
        Session session = null;
        Transaction transaction = null;
        try {
            session = getSession();
            transaction = session.beginTransaction();
            session.save(order);
            transaction.commit();
        } catch (HibernateException ex) {
            if (transaction != null) {
                try {
                    transaction.rollback();
                } catch (HibernateException ignore) { }
            }
            throw new RuntimeException(ex.getMessage());
        } finally {
            if (session != null) {
                try {
                    session.close();
                } catch (HibernateException ignore) { }
            }
        }
    }

    /** I[_܂B */
    public List find(String phone, Date from, Date to) {
        List result = null;
        Session session = null;
        try {
            session = getSession();
            Criteria criteria = session.createCriteria(Order.class);
            if (from != null) {
                criteria.add(Expression.ge("orderDate", from));
            }
            if (to != null) {
                criteria.add(Expression.lt("orderDate", to));
            }
            if (phone != null) {
                criteria.createCriteria("customer").
                    add(Expression.eq("phone", phone));
            }
            result = criteria.list();
        } catch (HibernateException ex) {
            throw new RuntimeException(ex.getMessage());
        } finally {
            if (session != null) {
                try {
                    session.close();
                } catch (HibernateException ignore) { }
            }
        }
        return result;
    }

    /** I[_ڍׂ擾܂B */
    public Order getOrderWithDetails(Serializable id) {
        Order result = null;
        Session session = null;
        try {
            session = getSession();
            List list = session.find(
                "from Order o left join fetch o.details where o.id = ?",
                id, Hibernate.INTEGER);
            if (!list.isEmpty()) {
                result = (Order)list.get(0);
            }
        } catch (HibernateException ex) {
            throw new RuntimeException(ex.getMessage());
        } finally {
            if (session != null) {
                try {
                    session.close();
                } catch (HibernateException ignore) { }
            }
        }
        return result;
    }
}
